local AddMyParty_List

function AddMyParty_Command(com)
	AddMyParty_List = {}
	for i = 1, 4 do
		local name, realm = UnitName("party" .. i)
		if not name or not (realm == nil or realm == '') then break end -- Party not full
		AddFriend(name)
		AddMyParty_List[#AddMyParty_List + 1] = name
	end
	ShowFriends()
end

function AddMyParty_GenerateNote(com)
	if com and com ~= "" then return com end
	return string.format(
		"AMP: %s <%s>",
		GetRealZoneText(),
		date("%d/%m/%y %H:%M")
	)
end

local InEvent = false -- Stack overflow / infinite recursion protection

function AddMyParty_OnEvent(event, arg1, arg2, arg3)
	if InEvent or not AddMyParty_List then return end
	InEvent = true
	for i = 1, GetNumFriends() do
		local name = GetFriendInfo(i)
		for k,v in ipairs(AddMyParty_List) do
			if name == v then
				SetFriendNotes(i, AddMyParty_GenerateNote(com))
				break
			end
		end
	end
	InEvent = false
	AddMyParty_List = nil
end

if not AddMyParty_Frame then
	AddMyParty_Frame = CreateFrame("Frame", "AddMyParty_Frame")
end

AddMyParty_Frame:SetScript("OnEvent", function() AddMyParty_OnEvent(event, arg1, arg2, arg3) end)

AddMyParty_Frame:RegisterEvent("FRIENDLIST_UPDATE")
AddMyParty_Frame:RegisterEvent("FRIENDLIST_SHOW")

SLASH_ADDMYPARTY1 = "/addmyparty"
SLASH_ADDMYPARTY2 = "/amp"
SlashCmdList["ADDMYPARTY"] = AddMyParty_Command
